=== debian/changelog ===
gammaray (3.1.0+ds-3ubuntu4) questing; urgency=medium

  * d/patches: Add upstream_fix-gammray-build-Qt-6.9.patch
    https://github.com/KDAB/GammaRay/commit/73a102f5
  * Make flaky tests non fatal.
  * Fix build with GCS on arm64.

 -- Rik Mills <rikmills@kde.org>  Thu, 18 Sep 2025 11:12:30 +0100

gammaray (3.1.0+ds-3ubuntu3) questing; urgency=medium

  * d/patches: Add upstream_fix-gammray-build-Qt-6.9.patch
    https://github.com/KDAB/GammaRay/commit/73a102f5

 -- Rik Mills <rikmills@kde.org>  Wed, 17 Sep 2025 13:43:16 +0100

gammaray (3.1.0+ds-3ubuntu2) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Wed, 17 Sep 2025 06:29:20 +0100

gammaray (3.1.0+ds-3ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining chanages:
    - Disable LauncherTest and ClientConnectionTest that fail on Ubuntu
      because of ptrace protection.

 -- Rik Mills <rikmills@kde.org>  Thu, 22 May 2025 11:08:00 +0100

gammaray (3.1.0+ds-3) unstable; urgency=medium

  * Team upload.
  * Make it possible to build on non-Linux architectures:
    - limit the libwayland-dev, qt6-connectivity-dev, qt6-wayland, and
      qt6-wayland-dev build dependencies as linux-any
    - limit the gammaray-plugin-waylandinspector, and gammaray-plugin-bluetooth
      binary packages as linux-any
  * Remove the unneeded libproj-dev build dependency. (Closes: #1050765)
  * Simplify debian-archs-fix-build.patch for GNU/Hurd: accept the x86 string
    with the AT386 suffix as i686.
  * Add the configuration for the CI on salsa.
  * Bump Standards-Version to 4.7.2, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 05 Apr 2025 10:56:31 +0200

gammaray (3.1.0+ds-2ubuntu3) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.3 (LP: #2103945).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 29 Mar 2025 15:12:42 -0500

gammaray (3.1.0+ds-2ubuntu2) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.2.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 05 Feb 2025 03:39:30 -0600

gammaray (3.1.0+ds-2ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable, remaining change:
    - Disable LauncherTest and ClientConnectionTest that fail on Ubuntu
      because of ptrace protection.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 12 Jan 2025 21:27:39 +0300

gammaray (3.1.0+ds-2) unstable; urgency=medium

  * Team upload.

  [ Dmitry Shachnev ]
  * Drop disable-qmllint.patch. Instead, add qml6-module-qtquick-templates
    to build-dependencies; this makes qmllint not crash.

  [ Santiago Vila ]
  * Disable flaky tests. Closes: #1017144.

 -- Dmitry Shachnev <mitya57@debian.org>  Mon, 23 Sep 2024 13:00:22 +0300

gammaray (3.1.0+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Repack upstream tarball to exclude bundled copy of graphviz.
    This reduces the tarball size from 60 MB to 11 MB.
  * Refresh patches for the new release.
  * Update debian/copyright.
  * Export LC_ALL=C.UTF-8 in debian/rules.
  * Build-depend on qml6-module-qtquick-{controls,window}.
  * Add a patch to not run qmllint on quick-event-handling.qml.
  * Stop installing gammaray_qtivi_ui.so.
  * Upload to unstable.

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 22 Sep 2024 20:11:18 +0300

gammaray (3.0.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update Build-Depends and Depends from Qt 5 to Qt 6.
  * Remove "export QT_SELECT=5" from debian/rules.
  * Drop increase-test-timeout.patch, applied upstream.
  * Refresh and rebase other patches.
    - Drop GNU/kFreeBSD support from debian-archs-fix-build.patch.
  * Update install files for switch to Qt 6.
  * Disable plugins which are not available:
    - codecbrowser, statemachineviewer, scriptenginedebugger (Qt 5 only).
    - objectvisualizer (removed in the new release).
  * Install the new openglsupport plugin.
  * Update debian/copyright.
  * Update the command to remove licenses from /usr/share/doc/gammaray.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Dmitry Shachnev <mitya57@debian.org>  Sat, 15 Jun 2024 23:04:21 +0300

gammaray (2.11.3-4) unstable; urgency=medium

  * Team upload.
  * Stop depending on qtwebengine5-dev on mipsel (closes: #1041265).

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 16 Jul 2023 19:33:07 +0300
