=== debian/watch ===
version=4
opts=searchmode=plain,pgpsigurlmangle=s/$/.asc/,dversionmangle=auto,repacksuffix=+ds \
https://api.github.com/repos/KDAB/GammaRay/releases \
https://github.com/KDAB/GammaRay/releases/download/v[\d.]+/gammaray-([\d.]+)\.tar\.gz
